diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/applications/model/udp-client.cc ns-3.39/src/applications/model/udp-client.cc
--- ns-3.38/src/applications/model/udp-client.cc	2023-03-16 20:54:23.580868500 -0700
+++ ns-3.39/src/applications/model/udp-client.cc	2023-07-05 14:23:47.705427000 -0700
@@ -76,7 +76,15 @@
                           "the size of the header carrying the sequence number and the time stamp.",
                           UintegerValue(1024),
                           MakeUintegerAccessor(&UdpClient::m_size),
-                          MakeUintegerChecker<uint32_t>(12, 65507));
+                          MakeUintegerChecker<uint32_t>(12, 65507))
+            .AddTraceSource("Tx",
+                            "A new packet is created and sent",
+                            MakeTraceSourceAccessor(&UdpClient::m_txTrace),
+                            "ns3::Packet::TracedCallback")
+            .AddTraceSource("TxWithAddresses",
+                            "A new packet is created and sent",
+                            MakeTraceSourceAccessor(&UdpClient::m_txTraceWithAddresses),
+                            "ns3::Packet::TwoAddressTracedCallback");
     return tid;
 }
 
@@ -125,7 +133,7 @@
     {
         TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
         m_socket = Socket::CreateSocket(GetNode(), tid);
-        if (Ipv4Address::IsMatchingType(m_peerAddress) == true)
+        if (Ipv4Address::IsMatchingType(m_peerAddress))
         {
             if (m_socket->Bind() == -1)
             {
@@ -134,7 +142,7 @@
             m_socket->Connect(
                 InetSocketAddress(Ipv4Address::ConvertFrom(m_peerAddress), m_peerPort));
         }
-        else if (Ipv6Address::IsMatchingType(m_peerAddress) == true)
+        else if (Ipv6Address::IsMatchingType(m_peerAddress))
         {
             if (m_socket->Bind6() == -1)
             {
@@ -143,7 +151,7 @@
             m_socket->Connect(
                 Inet6SocketAddress(Ipv6Address::ConvertFrom(m_peerAddress), m_peerPort));
         }
-        else if (InetSocketAddress::IsMatchingType(m_peerAddress) == true)
+        else if (InetSocketAddress::IsMatchingType(m_peerAddress))
         {
             if (m_socket->Bind() == -1)
             {
@@ -151,7 +159,7 @@
             }
             m_socket->Connect(m_peerAddress);
         }
-        else if (Inet6SocketAddress::IsMatchingType(m_peerAddress) == true)
+        else if (Inet6SocketAddress::IsMatchingType(m_peerAddress))
         {
             if (m_socket->Bind6() == -1)
             {
@@ -203,9 +211,20 @@
 {
     NS_LOG_FUNCTION(this);
     NS_ASSERT(m_sendEvent.IsExpired());
+
+    Address from;
+    Address to;
+    m_socket->GetSockName(from);
+    m_socket->GetPeerName(to);
     SeqTsHeader seqTs;
     seqTs.SetSeq(m_sent);
-    Ptr<Packet> p = Create<Packet>(m_size - (8 + 4)); // 8+4 : the size of the seqTs header
+    NS_ABORT_IF(m_size < seqTs.GetSerializedSize());
+    Ptr<Packet> p = Create<Packet>(m_size - seqTs.GetSerializedSize());
+
+    // Trace before adding header, for consistency with PacketSink
+    m_txTrace(p);
+    m_txTraceWithAddresses(p, from, to);
+
     p->AddHeader(seqTs);
 
     if ((m_socket->Send(p)) >= 0)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/applications/model/udp-client.h ns-3.39/src/applications/model/udp-client.h
--- ns-3.38/src/applications/model/udp-client.h	2023-03-16 20:54:23.580868500 -0700
+++ ns-3.39/src/applications/model/udp-client.h	2023-07-05 14:23:47.705427000 -0700
@@ -26,6 +26,7 @@
 #include "ns3/event-id.h"
 #include "ns3/ipv4-address.h"
 #include "ns3/ptr.h"
+#include <ns3/traced-callback.h>
 
 namespace ns3
 {
@@ -82,6 +83,12 @@
      */
     void Send();
 
+    /// Traced Callback: transmitted packets.
+    TracedCallback<Ptr<const Packet>> m_txTrace;
+
+    /// Callbacks for tracing the packet Tx events, includes source and destination addresses
+    TracedCallback<Ptr<const Packet>, const Address&, const Address&> m_txTraceWithAddresses;
+
     uint32_t m_count; //!< Maximum number of packets the application will send
     Time m_interval;  //!< Packet inter-send time
     uint32_t m_size;  //!< Size of the sent packet (including the SeqTsHeader)
@@ -92,6 +99,7 @@
     Address m_peerAddress; //!< Remote peer address
     uint16_t m_peerPort;   //!< Remote peer port
     EventId m_sendEvent;   //!< Event to send the next packet
+
 #ifdef NS3_LOG_ENABLE
     std::string m_peerAddressString; //!< Remote peer address string
 #endif                               // NS3_LOG_ENABLE
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/applications/model/udp-echo-client.cc ns-3.39/src/applications/model/udp-echo-client.cc
--- ns-3.38/src/applications/model/udp-echo-client.cc	2023-03-16 20:54:23.580868500 -0700
+++ ns-3.39/src/applications/model/udp-echo-client.cc	2023-07-05 14:23:47.705427000 -0700
@@ -141,7 +141,7 @@
     {
         TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
         m_socket = Socket::CreateSocket(GetNode(), tid);
-        if (Ipv4Address::IsMatchingType(m_peerAddress) == true)
+        if (Ipv4Address::IsMatchingType(m_peerAddress))
         {
             if (m_socket->Bind() == -1)
             {
@@ -150,7 +150,7 @@
             m_socket->Connect(
                 InetSocketAddress(Ipv4Address::ConvertFrom(m_peerAddress), m_peerPort));
         }
-        else if (Ipv6Address::IsMatchingType(m_peerAddress) == true)
+        else if (Ipv6Address::IsMatchingType(m_peerAddress))
         {
             if (m_socket->Bind6() == -1)
             {
@@ -159,7 +159,7 @@
             m_socket->Connect(
                 Inet6SocketAddress(Ipv6Address::ConvertFrom(m_peerAddress), m_peerPort));
         }
-        else if (InetSocketAddress::IsMatchingType(m_peerAddress) == true)
+        else if (InetSocketAddress::IsMatchingType(m_peerAddress))
         {
             if (m_socket->Bind() == -1)
             {
@@ -167,7 +167,7 @@
             }
             m_socket->Connect(m_peerAddress);
         }
-        else if (Inet6SocketAddress::IsMatchingType(m_peerAddress) == true)
+        else if (Inet6SocketAddress::IsMatchingType(m_peerAddress))
         {
             if (m_socket->Bind6() == -1)
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/applications/model/udp-trace-client.cc ns-3.39/src/applications/model/udp-trace-client.cc
--- ns-3.38/src/applications/model/udp-trace-client.cc	2023-03-16 20:54:23.580868500 -0700
+++ ns-3.39/src/applications/model/udp-trace-client.cc	2023-07-05 14:23:47.705427000 -0700
@@ -48,7 +48,7 @@
 /**
  * \brief Default trace to send
  */
-struct UdpTraceClient::TraceEntry UdpTraceClient::g_defaultEntries[] = {
+UdpTraceClient::TraceEntry UdpTraceClient::g_defaultEntries[] = {
     {0, 534, 'I'},
     {40, 1542, 'P'},
     {120, 134, 'B'},
@@ -258,7 +258,7 @@
     {
         TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
         m_socket = Socket::CreateSocket(GetNode(), tid);
-        if (Ipv4Address::IsMatchingType(m_peerAddress) == true)
+        if (Ipv4Address::IsMatchingType(m_peerAddress))
         {
             if (m_socket->Bind() == -1)
             {
@@ -267,7 +267,7 @@
             m_socket->Connect(
                 InetSocketAddress(Ipv4Address::ConvertFrom(m_peerAddress), m_peerPort));
         }
-        else if (Ipv6Address::IsMatchingType(m_peerAddress) == true)
+        else if (Ipv6Address::IsMatchingType(m_peerAddress))
         {
             if (m_socket->Bind6() == -1)
             {
@@ -276,7 +276,7 @@
             m_socket->Connect(
                 Inet6SocketAddress(Ipv6Address::ConvertFrom(m_peerAddress), m_peerPort));
         }
-        else if (InetSocketAddress::IsMatchingType(m_peerAddress) == true)
+        else if (InetSocketAddress::IsMatchingType(m_peerAddress))
         {
             if (m_socket->Bind() == -1)
             {
@@ -284,7 +284,7 @@
             }
             m_socket->Connect(m_peerAddress);
         }
-        else if (Inet6SocketAddress::IsMatchingType(m_peerAddress) == true)
+        else if (Inet6SocketAddress::IsMatchingType(m_peerAddress))
         {
             if (m_socket->Bind6() == -1)
             {
@@ -329,11 +329,11 @@
     p->AddHeader(seqTs);
 
     std::stringstream addressString;
-    if (Ipv4Address::IsMatchingType(m_peerAddress) == true)
+    if (Ipv4Address::IsMatchingType(m_peerAddress))
     {
         addressString << Ipv4Address::ConvertFrom(m_peerAddress);
     }
-    else if (Ipv6Address::IsMatchingType(m_peerAddress) == true)
+    else if (Ipv6Address::IsMatchingType(m_peerAddress))
     {
         addressString << Ipv6Address::ConvertFrom(m_peerAddress);
     }
@@ -362,7 +362,7 @@
 
     bool cycled = false;
     Ptr<Packet> p;
-    struct TraceEntry* entry = &m_entries[m_currentEntry];
+    TraceEntry* entry = &m_entries[m_currentEntry];
     do
     {
         for (uint32_t i = 0; i < entry->packetSize / m_maxPacketSize; i++)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/bridge/test/examples-to-run.py ns-3.39/src/bridge/test/examples-to-run.py
--- ns-3.38/src/bridge/test/examples-to-run.py	2023-03-16 20:54:23.580868500 -0700
+++ ns-3.39/src/bridge/test/examples-to-run.py	2023-07-05 14:23:47.709426900 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/brite/examples/brite-generic-example.cc ns-3.39/src/brite/examples/brite-generic-example.cc
--- ns-3.38/src/brite/examples/brite-generic-example.cc	2023-03-16 20:54:23.580868500 -0700
+++ ns-3.39/src/brite/examples/brite-generic-example.cc	2023-07-05 14:23:47.709426900 -0700
@@ -1,4 +1,6 @@
 /*
+ * Copyright (c) 2012 The Georgia Institute of Technology
+ *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
  * published by the Free Software Foundation;
@@ -12,6 +14,7 @@
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
+ * Author: Brian Swenson <bswenson3@gatech.edu>
  */
 
 #include "Brite.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/brite/examples/brite-generic-example.py ns-3.39/src/brite/examples/brite-generic-example.py
--- ns-3.38/src/brite/examples/brite-generic-example.py	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/src/brite/examples/brite-generic-example.py	2023-07-05 14:23:47.709426900 -0700
@@ -0,0 +1,104 @@
+#
+# Copyright (c) 2012 The Georgia Institute of Technology
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License version 2 as
+# published by the Free Software Foundation;
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+# Author: Brian Swenson <bswenson3@gatech.edu>
+# Modified by: Gabriel Ferreira <gabrielcarvfer@gmail.com>
+#
+
+from ns import ns
+
+ns.LogComponentEnable("BriteTopologyHelper", ns.LOG_LEVEL_ALL)
+
+# BRITE needs a configuration file to build its graph. By default, this
+# example will use the TD_ASBarabasi_RTWaxman.conf file. There are many others
+# which can be found in the BRITE/conf_files directory
+confFile = "src/brite/examples/conf_files/TD_ASBarabasi_RTWaxman.conf"
+
+# Invoke the BriteTopologyHelper and pass in a BRITE
+# configuration file and a seed file. This will use
+# BRITE to build a graph from which we can build the ns-3 topology
+bth = ns.BriteTopologyHelper(confFile)
+bth.AssignStreams(3)
+
+p2p = ns.PointToPointHelper()
+
+stack = ns.InternetStackHelper()
+
+nixRouting = ns.Ipv4NixVectorHelper()
+stack.SetRoutingHelper(nixRouting)
+
+address = ns.Ipv4AddressHelper()
+address.SetBase("10.0.0.0", "255.255.255.252")
+
+bth.BuildBriteTopology(stack)
+bth.AssignIpv4Addresses(address)
+
+print(f"Number of AS created {bth.GetNAs()}")
+
+# The BRITE topology generator generates a topology of routers.  Here we create
+# two subnetworks which we attach to router leaf nodes generated by BRITE
+# use just one node
+client = ns.NodeContainer()
+server = ns.NodeContainer()
+
+client.Create(1)
+stack.Install(client)
+
+# install client node on last leaf node of AS 0
+numLeafNodesInAsZero = bth.GetNLeafNodesForAs(0)
+client.Add(bth.GetLeafNodeForAs(0, numLeafNodesInAsZero - 1))
+
+server.Create(1)
+stack.Install(server)
+
+# install server node on last leaf node on AS 1
+numLeafNodesInAsOne = bth.GetNLeafNodesForAs(1)
+server.Add(bth.GetLeafNodeForAs(1, numLeafNodesInAsOne - 1))
+
+p2p.SetDeviceAttribute("DataRate", ns.StringValue("5Mbps"))
+p2p.SetChannelAttribute("Delay", ns.StringValue("2ms"))
+
+p2pClientDevices = p2p.Install(client)
+p2pServerDevices = p2p.Install(server)
+
+address.SetBase("10.1.0.0", "255.255.0.0")
+clientInterfaces = address.Assign(p2pClientDevices)
+
+address.SetBase("10.2.0.0", "255.255.0.0")
+serverInterfaces = ns.Ipv4InterfaceContainer()
+serverInterfaces = address.Assign(p2pServerDevices)
+
+echoServer = ns.UdpEchoServerHelper(9)
+serverApps = echoServer.Install(server.Get(0))
+serverApps.Start(ns.Seconds(1.0))
+serverApps.Stop(ns.Seconds(5.0))
+
+echoClient = ns.UdpEchoClientHelper(serverInterfaces.GetAddress(0).ConvertTo(), 9)
+echoClient.SetAttribute("MaxPackets", ns.UintegerValue(1))
+echoClient.SetAttribute("Interval", ns.TimeValue(ns.Seconds(1.)))
+echoClient.SetAttribute("PacketSize", ns.UintegerValue(1024))
+
+clientApps = echoClient.Install(client.Get(0))
+clientApps.Start(ns.Seconds(2.0))
+clientApps.Stop(ns.Seconds(5.0))
+
+asciiTrace = ns.AsciiTraceHelper()
+p2p.EnableAsciiAll(asciiTrace.CreateFileStream("briteLeaves.tr"))
+
+# Run the simulator
+ns.Simulator.Stop(ns.Seconds(6.0))
+ns.Simulator.Run()
+ns.Simulator.Destroy()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/brite/examples/brite-MPI-example.cc ns-3.39/src/brite/examples/brite-MPI-example.cc
--- ns-3.38/src/brite/examples/brite-MPI-example.cc	2023-03-16 20:54:23.580868500 -0700
+++ ns-3.39/src/brite/examples/brite-MPI-example.cc	2023-07-05 14:23:47.709426900 -0700
@@ -1,4 +1,6 @@
 /*
+ * Copyright (c) 2012 The Georgia Institute of Technology
+ *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
  * published by the Free Software Foundation;
@@ -12,6 +14,7 @@
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
+ * Author: Brian Swenson <bswenson3@gatech.edu>
  */
 
 #include "Brite.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/brite/helper/brite-topology-helper.cc ns-3.39/src/brite/helper/brite-topology-helper.cc
--- ns-3.38/src/brite/helper/brite-topology-helper.cc	2023-03-16 20:54:23.580868500 -0700
+++ ns-3.39/src/brite/helper/brite-topology-helper.cc	2023-07-05 14:23:47.713427000 -0700
@@ -412,8 +412,8 @@
     NS_LOG_LOGIC("Assigning << " << m_numAs << " AS to " << systemCount << " MPI instances");
     for (uint32_t i = 0; i < m_numAs; ++i)
     {
-        int val = i % systemCount;
-        m_systemForAs.push_back(val);
+        uint32_t val = i % systemCount;
+        m_systemForAs.push_back(static_cast<int>(val));
         NS_LOG_INFO("AS: " << i << " System: " << val);
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/brite/test/examples-to-run.py ns-3.39/src/brite/test/examples-to-run.py
--- ns-3.38/src/brite/test/examples-to-run.py	2023-03-16 20:54:23.580868500 -0700
+++ ns-3.39/src/brite/test/examples-to-run.py	2023-07-05 14:23:47.713427000 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
@@ -17,4 +16,6 @@
 #     (example_name, do_run).
 #
 # See test.py for more information.
-python_examples = []
+python_examples = [
+    ("brite-generic-example.py", "ENABLE_BRITE == True"),
+]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/buildings/CMakeLists.txt ns-3.39/src/buildings/CMakeLists.txt
--- ns-3.38/src/buildings/CMakeLists.txt	2023-03-16 20:54:23.580868500 -0700
+++ ns-3.39/src/buildings/CMakeLists.txt	2023-07-05 14:23:47.713427000 -0700
@@ -33,11 +33,12 @@
   LIBRARIES_TO_LINK ${libmobility}
                     ${libpropagation}
   TEST_SOURCES
-    test/building-position-allocator-test.cc
+    test/buildings-channel-condition-model-test.cc
     test/buildings-helper-test.cc
     test/buildings-pathloss-test.cc
+    test/buildings-penetration-loss-pathloss-test.cc
+    test/building-position-allocator-test.cc
     test/buildings-shadowing-test.cc
-    test/buildings-channel-condition-model-test.cc
     test/outdoor-random-walk-test.cc
     test/three-gpp-v2v-channel-condition-model-test.cc
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/buildings/examples/outdoor-group-mobility-example.cc ns-3.39/src/buildings/examples/outdoor-group-mobility-example.cc
--- ns-3.38/src/buildings/examples/outdoor-group-mobility-example.cc	2023-03-16 20:54:23.580868500 -0700
+++ ns-3.39/src/buildings/examples/outdoor-group-mobility-example.cc	2023-07-05 14:23:47.713427000 -0700
@@ -176,7 +176,7 @@
     // configuration.
 
     int64_t streamIndex = 1;
-    if (useHelper == false)
+    if (!useHelper)
     {
         // The reference (parent) mobility model starts at coordinate (10, 10, 0)
         // and performs a buildings-aware random walk.
@@ -196,7 +196,7 @@
         outdoorMm->SetPosition(Vector(10, 10, 0));
         streamIndex += outdoorMm->AssignStreams(streamIndex);
 
-        // Each HierachicalMobilityModel contains the above model as the Parent,
+        // Each HierarchicalMobilityModel contains the above model as the Parent,
         // and a user defined model as the Child.  Two MobilityModel objects are
         // instantiated per node, and each node also shares the same parent model.
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/buildings/helper/building-allocator.h ns-3.39/src/buildings/helper/building-allocator.h
--- ns-3.38/src/buildings/helper/building-allocator.h	2023-03-16 20:54:23.580868500 -0700
+++ ns-3.39/src/buildings/helper/building-allocator.h	2023-07-05 14:23:47.713427000 -0700
@@ -76,11 +76,11 @@
      */
     void PushAttributes() const;
 
-    mutable uint32_t m_current;                          //!< current building number
-    enum GridPositionAllocator::LayoutType m_layoutType; //!< Layout type
-    double m_xMin;                                       //!< The x coordinate where the grid starts
-    double m_yMin;                                       //!< The y coordinate where the grid starts
-    uint32_t m_n;     //!< The number of objects laid out on a line
+    mutable uint32_t m_current;                     //!< Current building number
+    GridPositionAllocator::LayoutType m_layoutType; //!< Layout type
+    double m_xMin;                                  //!< The x coordinate where the grid starts
+    double m_yMin;                                  //!< The y coordinate where the grid starts
+    uint32_t m_n;                                   //!< The number of objects laid out on a line
     double m_lengthX; //!< The length of the wall of each building along the X axis.
     double m_lengthY; //!< The length of the wall of each building along the Y axis.
     double m_deltaX;  //!< The x space between buildings
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/buildings/model/buildings-channel-condition-model.cc ns-3.39/src/buildings/model/buildings-channel-condition-model.cc
--- ns-3.38/src/buildings/model/buildings-channel-condition-model.cc	2023-03-16 20:54:23.584868400 -0700
+++ ns-3.39/src/buildings/model/buildings-channel-condition-model.cc	2023-07-05 14:23:47.713427000 -0700
@@ -99,6 +99,35 @@
         {
             NS_LOG_DEBUG("a and b are indoor in different buildings");
             cond->SetLosCondition(ChannelCondition::LosConditionValue::NLOS);
+
+            ChannelCondition::O2iLowHighConditionValue lowHighLossConditionA1;
+            ChannelCondition::O2iLowHighConditionValue lowHighLossConditionB1;
+
+            // Low losses considered for Wood or ConcreteWithWindows, while
+            // high losses for ConcreteWithoutWindows and StoneBlocks
+            lowHighLossConditionA1 =
+                a1->GetBuilding()->GetExtWallsType() == Building::ExtWallsType_t::Wood ||
+                        a1->GetBuilding()->GetExtWallsType() ==
+                            Building::ExtWallsType_t::ConcreteWithWindows
+                    ? ChannelCondition::O2iLowHighConditionValue::LOW
+                    : ChannelCondition::O2iLowHighConditionValue::HIGH;
+
+            lowHighLossConditionB1 =
+                b1->GetBuilding()->GetExtWallsType() == Building::ExtWallsType_t::Wood ||
+                        b1->GetBuilding()->GetExtWallsType() ==
+                            Building::ExtWallsType_t::ConcreteWithWindows
+                    ? ChannelCondition::O2iLowHighConditionValue::LOW
+                    : ChannelCondition::O2iLowHighConditionValue::HIGH;
+
+            if (lowHighLossConditionA1 == ChannelCondition::O2iLowHighConditionValue::HIGH ||
+                lowHighLossConditionB1 == ChannelCondition::O2iLowHighConditionValue::HIGH)
+            {
+                cond->SetO2iLowHighCondition(ChannelCondition::O2iLowHighConditionValue::HIGH);
+            }
+            else
+            {
+                cond->SetO2iLowHighCondition(ChannelCondition::O2iLowHighConditionValue::LOW);
+            }
         }
     }
     else // outdoor to indoor case
@@ -107,6 +136,31 @@
 
         NS_LOG_DEBUG("a is indoor and b outdoor or vice-versa");
         cond->SetLosCondition(ChannelCondition::LosConditionValue::NLOS);
+
+        ChannelCondition::O2iLowHighConditionValue lowHighLossCondition;
+        if (isAIndoor)
+        {
+            // Low losses considered for Wood or ConcreteWithWindows, while
+            // high losses for ConcreteWithoutWindows and StoneBlocks
+            lowHighLossCondition =
+                a1->GetBuilding()->GetExtWallsType() == Building::ExtWallsType_t::Wood ||
+                        a1->GetBuilding()->GetExtWallsType() ==
+                            Building::ExtWallsType_t::ConcreteWithWindows
+                    ? ChannelCondition::O2iLowHighConditionValue::LOW
+                    : ChannelCondition::O2iLowHighConditionValue::HIGH;
+
+            cond->SetO2iLowHighCondition(lowHighLossCondition);
+        }
+        else
+        {
+            lowHighLossCondition =
+                b1->GetBuilding()->GetExtWallsType() == Building::ExtWallsType_t::Wood ||
+                        b1->GetBuilding()->GetExtWallsType() ==
+                            Building::ExtWallsType_t::ConcreteWithWindows
+                    ? ChannelCondition::O2iLowHighConditionValue::LOW
+                    : ChannelCondition::O2iLowHighConditionValue::HIGH;
+            cond->SetO2iLowHighCondition(lowHighLossCondition);
+        }
     }
 
     return cond;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/buildings/test/buildings-channel-condition-model-test.cc ns-3.39/src/buildings/test/buildings-channel-condition-model-test.cc
--- ns-3.38/src/buildings/test/buildings-channel-condition-model-test.cc	2023-03-16 20:54:23.584868400 -0700
+++ ns-3.39/src/buildings/test/buildings-channel-condition-model-test.cc	2023-07-05 14:23:47.717427000 -0700
@@ -121,6 +121,7 @@
     building->SetNRoomsY(1);
     building->SetNFloors(1);
     building->SetBoundaries(Box(0.0, 10.0, 0.0, 10.0, 0.0, 5.0));
+    building->SetExtWallsType(Building::ExtWallsType_t::Wood);
 
     BuildingsHelper::Install(nodes);
 
